// Copyright (c) 2012 Cloudera, Inc.  All rights reserved.
define([
  "cloudera/Util",
  "cloudera/form/LabelOver"
], function(Util, LabelOver) {
  /**
   * Manages the Search Box on the Config UI.
   */
  return function(options){
    var onKeyup = function(evt) {
      var $this = $(this);
      Util.throttle(function(){
        $.publish("configSearchChanged", [$this.val()]);
      }, 200)();
    };

    var onKeypress = function(evt) {
      var code = evt.keyCode || evt.which;
      // Prevent enter key from submitting the form.
      if (code === $.ui.keyCode.ENTER) {
        evt.preventDefault();
        return false;
      }
    };
    $('label[for="configSearch"]')
      .removeClass('hidden')
      .labelOver('over');

    // Handles search terms on keyup and on change.
    $('#configSearch')
      .keyup(onKeyup)
      .change(onKeyup)
      .keypress(onKeypress)
      .focus();

    var searchQuery = options.searchQuery || "";
    if (searchQuery !== "") {
      $("#configSearch").val(searchQuery).trigger("change");
    }

    var onConfigNavChanged = function() {
      $("#configSearch").val("");
    };

    $.subscribe("configNavChanged", onConfigNavChanged);
  };
});
